VERSION 5.00
Begin VB.Form frmMain 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   " COLOR->GRAY SCALE"
   ClientHeight    =   6015
   ClientLeft      =   45
   ClientTop       =   435
   ClientWidth     =   7665
   BeginProperty Font 
      Name            =   "Tahoma"
      Size            =   8.25
      Charset         =   204
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   Icon            =   "frmMain.frx":0000
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   6015
   ScaleWidth      =   7665
   StartUpPosition =   2  'CenterScreen
   Begin VB.CommandButton cmdOpen 
      Caption         =   ""
      Height          =   315
      Left            =   6420
      TabIndex        =   4
      Top             =   5160
      Width           =   1155
   End
   Begin VB.TextBox txtFilepath 
      Height          =   315
      Left            =   60
      TabIndex        =   3
      Text            =   "___"
      Top             =   5160
      Width           =   6315
   End
   Begin VB.CommandButton Command1 
      Caption         =   "  "
      Default         =   -1  'True
      BeginProperty Font 
         Name            =   "Tahoma"
         Size            =   8.25
         Charset         =   204
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   5220
      TabIndex        =   1
      Top             =   5580
      Width           =   2355
   End
   Begin VB.PictureBox picPicture 
      AutoRedraw      =   -1  'True
      AutoSize        =   -1  'True
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   204
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   5055
      Left            =   60
      Picture         =   "frmMain.frx":000C
      ScaleHeight     =   333
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   500
      TabIndex        =   0
      Top             =   60
      Width           =   7560
   End
   Begin VB.Label lblStatus 
      Height          =   255
      Left            =   60
      TabIndex        =   2
      Top             =   5640
      Width           =   5115
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

'Private Declare Function GetObjectAPI Lib "gdi32" Alias "GetObjectA" (ByVal hObject As Long, ByVal nCount As Long, lpObject As Any) As Long
Private Declare Function SetDIBitsToDevice Lib "gdi32" (ByVal hDC As Long, ByVal x As Long, ByVal y As Long, ByVal dx As Long, ByVal dy As Long, ByVal SrcX As Long, ByVal SrcY As Long, ByVal Scan As Long, ByVal NumScans As Long, Bits As Any, BitsInfo As Any, ByVal wUsage As Long) As Long
'Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (lpvDest As Any, lpvSource As Any, ByVal cbCopy As Long)
Private Declare Function GetDIBits Lib "gdi32" (ByVal aHDC As Long, ByVal hBitmap As Long, ByVal nStartScan As Long, ByVal nNumScans As Long, lpBits As Any, lpBI As Any, ByVal wUsage As Long) As Long
'Private Declare Function CreateDIBitmap Lib "gdi32" (ByVal hDC As Long, lpbmih As BITMAPINFOHEADER, ByVal fdwInit As Long, lpbInit As Any, lpbmi As BITMAPINFO, ByVal fuUsage As Long) As Long
'Private Declare Function CreateBitmap Lib "gdi32" (ByVal nWidth As Long, ByVal nHeight As Long, ByVal nPlanes As Long, ByVal nBitCount As Long, lpBits As Any) As Long
Private Declare Function GetTickCount Lib "kernel32" () As Long

Private Type BITMAPINFOHEADER '40 bytes
  biSize As Long
  biWidth As Long
  biHeight As Long
  biPlanes As Integer
  biBitCount As Integer
  biCompression As Long
  biSizeImage As Long
  biXPelsPerMeter As Long
  biYPelsPerMeter As Long
  biClrUsed As Long
  biClrImportant As Long
End Type
Private Type RGBQUAD
  rgbBlue As Byte
  rgbGreen As Byte
  rgbRed As Byte
  rgbReserved As Byte
End Type

Private Type BITMAPINFO
  bmiHeader As BITMAPINFOHEADER
  bmiColors(0 To 255) As RGBQUAD
End Type

Private Const CBM_INIT = 4&

Private m_BoundedPB As PictureBox

Private Function SetBits(pb As PictureBox, abPicture() As Byte, BI As BITMAPINFO) As Boolean
  SetBits = SetDIBitsToDevice(pb.hDC, 0, 0, BI.bmiHeader.biWidth, BI.bmiHeader.biHeight, 0, 0, 0, BI.bmiHeader.biHeight, abPicture(0, 0), BI, 0)
  pb.Refresh
End Function

Private Function GetTrueBits(pb As PictureBox, abPicture() As RGBQUAD) As Boolean
Dim BI As BITMAPINFOHEADER
  With BI
    .biSize = LenB(BI)
    .biWidth = pb.ScaleX(pb.Picture.Width, vbHimetric, vbPixels)
    .biHeight = pb.ScaleY(pb.Picture.Height, vbHimetric, vbPixels)
    .biPlanes = 1
    .biBitCount = 32
    .biCompression = 0
    .biSizeImage = .biWidth * .biHeight * 4
    ReDim abPicture(.biWidth - 1, .biHeight - 1)
  End With
  GetTrueBits = GetDIBits(pb.hDC, pb.Picture, 0, BI.biHeight, abPicture(0, 0), BI, 0)
End Function

Public Sub ProccessGrayScale()
Dim m_abPicture() As RGBQUAD, m_gsPicture() As Byte
  Call GetTrueBits(m_BoundedPB, m_abPicture)
  ReDim m_gsPicture(UBound(m_abPicture, 1), UBound(m_abPicture, 2))
  Call GrayScale(m_abPicture, m_gsPicture)
  
Dim m_BI As BITMAPINFO, i As Long
For i = 0 To 255
With m_BI.bmiColors(i)
    .rgbRed = i: .rgbGreen = i: .rgbBlue = i
End With
Next
With m_BI.bmiHeader
    .biSize = LenB(m_BI.bmiHeader)
    .biWidth = UBound(m_gsPicture, 1) + 1
    .biHeight = UBound(m_gsPicture, 2) + 1
    .biPlanes = 1
    .biBitCount = 8
    .biCompression = 0
    .biSizeImage = .biWidth * .biHeight
    .biClrUsed = 256
End With
  m_BoundedPB.Picture = LoadPicture()
  SetBits m_BoundedPB, m_gsPicture, m_BI
  m_BoundedPB.Picture = m_BoundedPB.Image

  Open "c:\temp\out.bmp" For Output As 1: Close 1
  Open "c:\temp\out.bmp" For Binary As 1
  Put #1, , "BM"
  Put #1, , 14 + Len(m_BI) + m_BI.bmiHeader.biSizeImage
  Put #1, , 0&
  Put #1, , 14&
  Put #1, , m_BI
  Put #1, , m_gsPicture()
  Close 1
End Sub

Private Sub GrayScale(abPicture() As RGBQUAD, gsPicture() As Byte)
  Dim x As Long, y As Long
  Dim xMax As Long, yMax As Long
  Dim lGray As Long
  Dim lTime As Long
  
  lTime = GetTickCount
  xMax = UBound(abPicture, 1)
  yMax = UBound(abPicture, 2)
  '    xMax
  For x = 0 To xMax
    For y = 0 To yMax
      With abPicture(x, y)
        lGray = (299& * .rgbRed + 587& * .rgbGreen + 114& * .rgbBlue) / 1000
      End With
      gsPicture(x, y) = lGray
    Next y
    If (x Mod 15) = 0 Then
      '  (  - x)
    End If
  Next x
  
  lblStatus.Caption = (GetTickCount - lTime) / 1000 & " ."
End Sub

Private Sub cmdOpen_Click()
  If (Len(Dir(txtFilepath)) = 0) Then Exit Sub
  Set picPicture.Picture = LoadPicture(txtFilepath)
End Sub
Private Sub Form_Unload(Cancel As Integer)
  Set m_BoundedPB = Nothing
End Sub

Private Sub Command1_Click()
  Set m_BoundedPB = picPicture
  lblStatus.Caption = "...": MousePointer = vbHourglass: Refresh
  ProccessGrayScale
  MousePointer = vbDefault
End Sub
